#pragma hdrstop

#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include "msvcrttest.h"

static void pause(void)
{
    printf("\nPress any key... ");
    getch();
    printf("\n\n");
}

#define NO_TEST         0
#define MATH_TEST       1
#define STDLIB_TEST     2
#define STDIO_TEST      3
#define TIME_TEST       4
#define CTYPE_TEST      5
#define STRING_TEST     6
#define EXIT_TEST       255

struct menuitem
{
    int id;
    char *str;
};

struct menuitem menustrs[] = {
    { MATH_TEST, "math test", },
    { STDLIB_TEST, "stdlib test" },
    { STDIO_TEST, "stdio test" },
    { TIME_TEST, "time test" },
    { CTYPE_TEST, "ctype test" },
    { STRING_TEST, "string test" },
    { EXIT_TEST, "exit" },
    { NO_TEST, "Internal error" }
};

void center(const char *s)
{
    int i;
    
    for (i = 0; i < (80 - strlen(s)) / 2; i++)
        putchar(' ');
    puts(s);
}

int menu(void)
{
    int i, max;
    char line[100];

    center("Object file generator and tester for msvcrt.dll");
    puts("\n\n");

    // Find longest string.
    for (i = 0; menustrs[i].id != NO_TEST; i++)
        if (max < strlen(menustrs[i].str))
            max = strlen(menustrs[i].str);

    // Display and center menu items.
    for (i = 0; menustrs[i].id != NO_TEST; i++)
    {
        sprintf(line, "%2d: %-60s", i + 1, menustrs[i].str);
        line[max + 4] = '\0';
        center(line);
        puts("\n");
    }

    // Get input.
    max = i;
    puts("\n\n");
    center("Please enter your choice... ");
    do
    {
        i = getch();
        if (i == 27)
            i = max - 1;
        else
            i = i - '1';
    } while((i < 0 || i >= max));

    // return chosen id.
    return menustrs[i].id;
}

#pragma argsused
int main(int argc, char* argv[])
{
    int i;

    for(;;)
    {
        clrscr();
        i = menu();
        switch(i)
        {
            case MATH_TEST:
                clrscr();
                mathtest();
                pause();
                break;
            case STDLIB_TEST:
                clrscr();
                stdlibtest();
                pause();
                break;
            case STDIO_TEST:
                clrscr();
                stdiotest();
                pause();
                break;
            case TIME_TEST:
                clrscr();
                timetest();
                pause();
                break;
            case CTYPE_TEST:
                clrscr();
                ctypetest();
                pause();
                break;
            case STRING_TEST:
                clrscr();
                stringtest();
                pause();
                break;
            case EXIT_TEST:
                exit(0);
                break;
            default:
                return 0;

        }
    }
}

